<script>
	import { getContext, onMount, setContext } from 'svelte'

	export let width = 30
	export let height = 30
	export let position

	export let marker = undefined
	let markerElement

	const layerGroup = getContext('layerGroup')()

	setContext('layer', () => marker)

	onMount(async () => {
		const Leaflet = await import('leaflet')
		let icon = Leaflet.divIcon({
			html: markerElement,
			className: 'map-marker',
			iconSize: Leaflet.point(width, height)
		})

		marker = Leaflet.marker(position, { icon }).addTo(layerGroup)

		return () => {
			marker?.remove()
		}
	})
</script>

<div bind:this={markerElement} class={$$restProps.class}>
	{#if marker}
		<slot />
	{/if}
</div>
